package cn.net.caoyao.cpzshandset.service.thread.impl.common;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

import android.os.Handler;
import android.os.Message;
import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.SingleLabelOptionBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.InternalOptionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.service.bll.ActivateWithRelationBll;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20002ReqBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20017ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20017LabelBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20017CheckLabelStatus;
import cn.net.cpzslibs.prot.handset.newProt.Prot20075ActivateWithRelation;

public class CommonSubmitSingleRelationActivateThread implements Runnable {
	private long deviceId;
	private ActivateWithRelationBll bll;
	private SingleLabelBll labelBll;
	private UploadStatusBll uploadStatusBll;
	private ActivateBean activateBean;
	private List<SingleLabelOptionBean> singleOptions;
	private int option_type = HandsetOperation.OPERATION_ACTIVATE_WITH_RELATION_CONSTANT.getOption();
	private Handler mHandler;

	public CommonSubmitSingleRelationActivateThread(Handler mHandler, long deviceId, ActivateWithRelationBll bll,
			SingleLabelBll labelBll, UploadStatusBll uploadStatusBll, ActivateBean activateBean,
			List<SingleLabelOptionBean> singleOptions) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.uploadStatusBll = uploadStatusBll;
		this.activateBean = activateBean;
		this.singleOptions = singleOptions;
		this.labelBll = labelBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
		try {
			LogUtil.d(TConfig.Echo, "登录");
			create.createLoginCpzsHandset(deviceId);
			if (create.isResult()) {
				submitActivateInfo(create);
//				checkLabel(create, activateBean);
			} else {
				Message msg = new Message();
				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				msg.arg1 = create.getiErrCode();
				msg.obj = create.getErrMsg();
				mHandler.sendMessage(msg);
			}

		} catch (BindException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (ConnectException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally {
			new Prot02Logout().dealLogout(create);
		}
	}

	private void submitActivateInfo(SocketCreate create) throws IOException, SocketTimeoutException {
		Prot20075ActivateWithRelation activate = new Prot20075ActivateWithRelation();
		activate.submitActivateInfo(create, getReqBean());
		ProtStatusResBean resBean = activate.getResBean();
		if (resBean == null) {
			mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ACTIVATE_WITHOUT_RES);
			return;
		}

		if (resBean.getResult() == 0) {
			// 上传成功，插入记录到提交状态表
			uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
			bll.delActivateById(activateBean);
		} else {
			bll.updateActivateErrorById(resBean.getErrcode(), activateBean.getId());
			checkLabel(create, activateBean);
		}
		Message msg = mHandler.obtainMessage(RequestConstant.SUBMIT_ACTIVATE_WITH_RES);
		msg.obj = resBean;
		mHandler.sendMessage(msg);

	}

	private void checkLabel(SocketCreate create, ActivateBean activateBean) throws IOException {
		Prot20017CheckLabelStatus prot20017 = new Prot20017CheckLabelStatus();
		prot20017.checkLabel(create, getProt20017ReqBean(activateBean));
		if (prot20017.getResBean() != null && prot20017.getResBean().getResult() == 0) {
			List<Prot20017LabelBean> invilad = prot20017.getResBean().getLabel_invalid();
			if (invilad != null) {
				List<String> inviladLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : invilad) {
					inviladLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(inviladLabel, option_type, activateBean.getId(),
						InternalOptionConstant.SINGLE_LABEL_STATUS_INVALID);
			}

			List<Prot20017LabelBean> noActivate = prot20017.getResBean().getLabel_not_active();
			if (noActivate != null) {
				List<String> repeatLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : noActivate) {
					repeatLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(repeatLabel, option_type, activateBean.getId(),
						InternalOptionConstant.SINGLE_LABEL_STATUS_NO_ACTIVATE);
			}
			
			List<Prot20017LabelBean> not_package = prot20017.getResBean().getLabel_not_package();
			if (not_package != null) {
				List<String> notPackageLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : not_package) {
					notPackageLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(notPackageLabel, option_type, activateBean.getId(),
						InternalOptionConstant.SINGLE_LABEL_STATUS_NOT_PACKAGE_LABEL);
			}
		}

	}

	private Prot20017ReqBean getProt20017ReqBean(ActivateBean activateBean) {
		Prot20017ReqBean reqBean = new Prot20017ReqBean();
		reqBean.setLabels(getLabels());
		reqBean.setOpt(9);
		return reqBean;
	}

	private UploadBean getUploadBean(ActivateBean activateBean) {
		UploadBean b = new UploadBean();
		b.setLabel_count(labelBll.queryLabelCountById(option_type, activateBean.getId()));
		b.setOption_type(option_type);
		return b;
	}

	private Prot20002ReqBean getReqBean() {
		Prot20002ReqBean reqBean = new Prot20002ReqBean();
		reqBean.setProduct_id(activateBean.getProduct_id());
		reqBean.setProduce_date(activateBean.getProduct_date());
		reqBean.setProduce_batch(activateBean.getProduct_batch_number());
		reqBean.setProducer(activateBean.getProducer());
		reqBean.setType(Config.SINGLE_OPTION_LABEL_TYPE);
		reqBean.setSingle(getLabels());
		LogUtil.i(TConfig.Echo, "提交的数据：" + reqBean.toString());
		return reqBean;
	}

	private List<String> getLabels() {
		List<String> singles = new ArrayList<>();
		for (SingleLabelOptionBean sLBean : singleOptions) {
			singles.add(sLBean.getLabel_id());
		}
		return singles;
	}

}
